module MagicLink
  module ViewHelpers
    def magic_link_to(name = nil, options = nil, html_options = nil, &block)
      if block_given?
        name = format_to_url(name)
      else
        options = format_to_url(options)
      end
      link_to(name, options, html_options, &block)
    end
    
    def magic_link_to_if(condition, name, options = {}, html_options = {}, &block)
      if block_given?
        name = format_to_url(name)
      else
        options = format_to_url(options)
      end
      
      link_to_if(condition, name, options, html_options, &block)
    end
    
    def magic_link_to_unless(condition, name, options = {}, html_options = {}, &block)
      if block_given?
        name = format_to_url(name)
      else
        options = format_to_url(options)
      end
      
      link_to_unless(condition, name, options, html_options, &block)
    end
    
    private
    def format_to_url(smth)
      if smth.is_a?(String)
        URL.new(smth).to_url
      else
        smth
      end
    end
  end
end